<template>
  <el-pagination
    :current-page="model.CurrentPage"
    :page-size="model.RowNumber"
    layout="prev, pager, next"
    :total="model.MaxRows"
    :pager-count="pagerCount ?? 5"
    @current-change="onCurrentChange"
  ></el-pagination>
</template>

<script setup lang="ts">
import { Pagination } from "~~/models/common/pagination";

const emit = defineEmits<{
  (e: "update:modelValue", value: Pagination): void;
  (e: "change", value: number): void;
}>();
const props = defineProps<{
  modelValue: Pagination;
  pagerCount?: 5 | 7 | 9 | 11 | 13 | 15 | 17 | 19 | 21;
}>();

const model = computed({
  get: () => props.modelValue,
  set: (value) => emit("update:modelValue", value),
});

const onCurrentChange = (page: number) => {
  model.value.CurrentPage = page;
  emit("change", page);
};
</script>

<style scoped></style>
